Subject: Re: [6lo] Barry Leiba's No Objection on draft-ietf-6lo-minimal-fragment-12: (with COMMENT)

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Thu, 5 Mar 2020 15:45:44 +0000

Hello Barry

It seems that this is the review you made on version 10. I scanned and could not make a difference. I attached the emails for reference. 
I believe that the issues are solved for the most part in https://tools.ietf.org/rfcdiff?url2=draft-ietf-6lo-minimal-fragment-11.txt

Could it be that you wanted to review draft-ietf-6lo-fragment-recovery instead?

Many thanks again!

Pascal

Subject: RE: Barry Leiba's No Objection on draft-ietf-6lo-minimal-fragment-10: (with COMMENT)
From: "Pascal Thubert (pthubert)" <[email-masked]>
To: Barry Leiba <[email-masked]>
Cc: The IESG <[email-masked]>, "[email-masked]" <[email-masked]>, Carles Gomez <[email-masked]>, "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>
Date: Fri, 7 Feb 2020 15:46:06 +0000

Hello Barry:

>
> >>    This specification uses the following terms:
> >>
> >> I would say it “defines” these terms, no?
> >
> > Not really, they appear in RFC 4944, but ok
>
> OK, no... I hadn't realized (and didn't check) that they were defined in 4944.
> Sorry; leave as is.

Will roll back with next publication, no problem

Again, many thanks Barry!

Pascal

Subject: Re: Barry Leiba's No Objection on draft-ietf-6lo-minimal-fragment-10: (with COMMENT)
From: Barry Leiba <[email-masked]>
To: "Pascal Thubert (pthubert)" <[email-masked]>
Cc: The IESG <[email-masked]>, "[email-masked]" <[email-masked]>, Carles Gomez <[email-masked]>, "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>
Date: Fri, 7 Feb 2020 15:22:36 +0000

Hi, Pascal, and thanks for the quick reply and for addressing my
comments.  For anything I don't mention further below, all is OK.

> > I think this makes FRAG-ILE a normative reference (necessary security issues).
> > It would also be useful to have a “see Section 7” forward pointer here, so it’s
> > clear that the specific issues are discussed later in this document.
>
> It was never published and never will be, so procedure-wise that's calling for trouble.
> The paragraph now looks like:
> "
>    "IP Fragmentation Considered Fragile" [FRAG-ILE] discusses security
>    threats that are linked to using IP fragmentation.  The 6LoWPAN
>    fragmentation takes place underneath, but some issues described there
>    may still apply to 6LoWPAN fragments (as discussed in further details
>    in Section 7).
> "
> Works?

Ah, OK, I didn't realize it wasn't meant to be published formally.
Yes, I think this works, because section 7 has enough detail that it
can stand as its own normative reference.  Thanks.

> > I think this makes 4919 a normative reference (necessary terminology and
> > concepts).
>
> A downref but OK, I'll trust an IESG review on this : )

Yes, not a problem: downrefs are now common, unremarkable, and not
problematic, as we often publish terminology and architecture/concepts
documents as Informational.

>>    This specification uses the following terms:
>>
>> I would say it “defines” these terms, no?
>
> Not really, they appear in RFC 4944, but ok

OK, no... I hadn't realized (and didn't check) that they were defined
in 4944.  Sorry; leave as is.

> Which gives:
> "
>    6LoWPAN endpoints:  The 6LoWPAN endpoints are the first and last
>       nodes in an unbroken string of 6LoWPAN nodes.  They are in charge
>       of generating or expanding a 6LoWPAN header from/to a full IPv6
>       packet.  They are also the points where the fragmentation and
>       reassembly operations take place.
> "

I like it.

> > Should this be “limitations”, rather than “limits”?  It seems so.  Also
> > throughout Section 6.
...
> And later, changed to caveats on occasion, see:

Yes; "caveats" works too; thanks.

> > — Section 6 —
> > (Change “limits” to “limitations” throughout the section.) Doesn’t this
> > section need LWIG-VRB to be a normative reference?
>
> I do not think so. The whole idea in this section was that the text would be self-describing.
> People are free to dig in the LWIG spec but that is not needed to understand this text.

OK; that makes sense.

--
Barry

Subject: RE: Barry Leiba's No Objection on draft-ietf-6lo-minimal-fragment-10: (with COMMENT)
From: "Pascal Thubert (pthubert)" <[email-masked]>
To: Barry Leiba <[email-masked]>, The IESG <[email-masked]>
Cc: "[email-masked]" <[email-masked]>, Carles Gomez <[email-masked]>, "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>
Date: Fri, 7 Feb 2020 15:03:23 +0000

Hello Barry:

Many thanks for your review!

I published a new version with the outcome of this first pass, so you can easily check the changes in https://www.ietf.org/rfcdiff?url2=draft-ietf-6lo-minimal-fragment-11

Please find the discussion below:

> ----------------------------------------------------------------------
> COMMENT:
> ----------------------------------------------------------------------
>
> Thanks for an interesting and well-written document.  Just a batch of
> editorial
> comments:
>
> — Section 2.2 —
>
>    poor network behavior and, occasionally, trouble at application
>    layer.  That experience led to the definition of "Path MTU discovery"
>    [RFC8201] (PMTUD) protocol that limits fragmentation over the
>    Internet.
>
> This is missing two definite articles (“the”), one after “trouble at” and one
> after “definition of”.
>
>    "IP Fragmentation Considered Fragile" [FRAG-ILE] discusses security
>    threats that are linked to using IP fragmentation.  The 6LoWPAN
>    fragmentation takes place underneath, but some issues described there
>    may still apply to 6LoWPAN fragments.
>
> I think this makes FRAG-ILE a normative reference (necessary security issues).
> It would also be useful to have a “see Section 7” forward pointer here, so it’s
> clear that the specific issues are discussed later in this document.

It was never published and never will be, so procedure-wise that's calling for trouble.
The paragraph now looks like:
"
   "IP Fragmentation Considered Fragile" [FRAG-ILE] discusses security
   threats that are linked to using IP fragmentation.  The 6LoWPAN
   fragmentation takes place underneath, but some issues described there
   may still apply to 6LoWPAN fragments (as discussed in further details
   in Section 7).
"
Works?

>
>    Readers are expected to be familiar with all the terms and concepts
>    that are discussed in "IPv6 over Low-Power Wireless Personal Area
>    Networks (6LoWPANs): Overview, Assumptions, Problem Statement, and
>    Goals" [RFC4919] and "Transmission of IPv6 Packets over IEEE 802.15.4
>    Networks" [RFC4944].
>
> I think this makes 4919 a normative reference (necessary terminology and
> concepts).

A downref but OK, I'll trust an IESG review on this : )

>
>    Quoting the "Multiprotocol Label Switching (MPLS) Architecture"
>    [RFC3031]: with MPLS, 'packets are "labeled" before they are
>    forwarded'.  At subsequent hops, there is no further analysis of the
>    packet's network layer header.  Rather, the label is used as an index
>    into a table which specifies the next hop, and a new label".
>
> There’s a quote mismatch here: you should not end the quote after
> “forwarded”... but there should be a paragraph break after “forwarded.”,
> which makes the quoting awkward.  I suggest handling the quote differently
> and eliminating the need for awkward cross-paragraph quotation.  So it
> would look like this:
>
> NEW
>    "Multiprotocol Label Switching (MPLS) Architecture" [RFC3031]
>    says that with MPLS, 'packets are "labeled" before they are
>    forwarded.'  It goes on to say, “At subsequent hops, there is no
>    further analysis of the packet's network layer header.  Rather, the
>    label is used as an index into a table which specifies the next hop,
>    and a new label".
> END

Great! Adopted : )

> — Section 2.3 —
>
>    This specification uses the following terms:
>
> I would say it “defines” these terms, no?

Not really, they appear in RFC 4944, but ok

>    6LoWPAN endpoints:  The nodes in charge of generating or expanding a
>       6LoWPAN header from/to a full IPv6 packet.  The 6LoWPAN endpoints
>       are the points where fragmentation and reassembly take place.
>
> I gather that the usual case is that the 6LoWPAN endpoints are the first and
> last nodes in an unbroken string of 6LoWPAN nodes, yes?  If that’s correct, I
> think it would add to easy understanding if you said that.  (And if it’s not
> correct, we might want to figure out why I got that impression.)

Which gives:
"
   6LoWPAN endpoints:  The 6LoWPAN endpoints are the first and last
      nodes in an unbroken string of 6LoWPAN nodes.  They are in charge
      of generating or expanding a 6LoWPAN header from/to a full IPv6
      packet.  They are also the points where the fragmentation and
      reassembly operations take place.
"

>
> — Section 4 —
>
>    4. Limits of Per-Hop Fragmentation and Reassembly
>
>    There are at least 2 limits to doing per-hop fragmentation and
>    reassembly.  See [ARTICLE] for detailed simulation results on both
>    limits.
>
> Should this be “limitations”, rather than “limits”?  It seems so.  Also
> throughout Section 6.

We get:
"
   There are at least 2 limitations to doing per-hop fragmentation and
   reassembly.  See [ARTICLE] for detailed simulation results on both
   limitations.
"
And later, changed to caveats on occasion, see:
"
   Virtual Reassembly Buffer (VRB) is the implementation technique
   described in [LWIG-VRB] in which a forwarder does not reassemble each
   packet in its entirety before forwarding it.

   VRB overcomes the limitations listed in Section 4.  Nodes do not wait
   for the last fragment before forwarding, reducing end-to-end latency.
   Similarly, the memory footprint of VRB is just the VRB table,
   reducing the packet drop probability significantly.

   There are other caveats, however:

"

And

"
  The severity and occurrence of these caveats depends on the Link-
   Layer used.  Whether they are acceptable depends entirely on the
   requirements the application places on the network.

   If the caveats are present and not acceptable for the application,
   future specifications may define new protocols to overcome them.  One
   example is [FRAG-RECOV] which defines a protocol which allows
   fragment recovery.

"
Does that work?

>
> — Section 5 —
>
>    error and refrain from creating a state or attempting to forward.
>
> Make it “refrains”.

done

> — Section 6 —
> (Change “limits” to “limitations” throughout the section.) Doesn’t this
> section need LWIG-VRB to be a normative reference?

I do not think so. The whole idea in this section was that the text would be self-describing.
People are free to dig in the LWIG spec but that is not needed to understand this text.

>
>       because the IP header is required to route the
>       fragment and is only present in the first fragment.
>
> This sounds as if the IP header has to do some routing.  If you say “is required
> in order to route...”, that ambiguity goes away.

done

>
> — Section 7 —
>
>       along a path, but each node suffers a lesser hit. this is because
>
> Capitalize “This”.

Done

>
>       An implementation MUST protect itself to
>       keep the number of VRBs within capacity, and that old VRBs are
>
> You need another word before “that”: maybe “ensure”?

done

>
>       This sounds
>       difficult and mostly useless in a 6LoWPAN network since the
>       fragmentation is not end-to-end.
>
> “Sounds”?  “Is”, I should think; no?

applied

>
> — Section 9 —
>
>    Also many thanks to Georgies Papadopoulos
>
> I believe it’s “Georgios”.

Oups : )

>
>    and Francesca Palombini For their constructive
>    reviews through the IESG process.
>
> Lower-case “for”.  And did Sarah, Joerg, and Francesca really review this
> through the IESG process, when the IESG process is just now starting?

Changed to

"
for their constructive reviews through the IETF last call
   and IESG process.

"

Again many thanks Barry!

Pascal

Subject: Barry Leiba's No Objection on draft-ietf-6lo-minimal-fragment-10: (with COMMENT)
From: Barry Leiba via Datatracker <[email-masked]>
To: The IESG <[email-masked]>
Cc: "[email-masked]" <[email-masked]>, Carles Gomez <[email-masked]>, "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>
Date: Fri, 7 Feb 2020 06:03:45 +0000

Barry Leiba has entered the following ballot position for
draft-ietf-6lo-minimal-fragment-10: No Objection

When responding, please keep the subject line intact and reply to all
email addresses included in the To and CC lines. (Feel free to cut this
introductory paragraph, however.)

Please refer to https://www.ietf.org/iesg/statement/discuss-criteria.html
for more information about IESG DISCUSS and COMMENT positions.

The document, along with other ballot positions, can be found here:
https://datatracker.ietf.org/doc/draft-ietf-6lo-minimal-fragment/

----------------------------------------------------------------------
COMMENT:
----------------------------------------------------------------------

Thanks for an interesting and well-written document.  Just a batch of editorial
comments:

— Section 2.2 —

   poor network behavior and, occasionally, trouble at application
   layer.  That experience led to the definition of "Path MTU discovery"
   [RFC8201] (PMTUD) protocol that limits fragmentation over the
   Internet.

This is missing two definite articles (“the”), one after “trouble at” and one
after “definition of”.

   "IP Fragmentation Considered Fragile" [FRAG-ILE] discusses security
   threats that are linked to using IP fragmentation.  The 6LoWPAN
   fragmentation takes place underneath, but some issues described there
   may still apply to 6LoWPAN fragments.

I think this makes FRAG-ILE a normative reference (necessary security issues).
It would also be useful to have a “see Section 7” forward pointer here, so it’s
clear that the specific issues are discussed later in this document.

   Readers are expected to be familiar with all the terms and concepts
   that are discussed in "IPv6 over Low-Power Wireless Personal Area
   Networks (6LoWPANs): Overview, Assumptions, Problem Statement, and
   Goals" [RFC4919] and "Transmission of IPv6 Packets over IEEE 802.15.4
   Networks" [RFC4944].

I think this makes 4919 a normative reference (necessary terminology and
concepts).

   Quoting the "Multiprotocol Label Switching (MPLS) Architecture"
   [RFC3031]: with MPLS, 'packets are "labeled" before they are
   forwarded'.  At subsequent hops, there is no further analysis of the
   packet's network layer header.  Rather, the label is used as an index
   into a table which specifies the next hop, and a new label".

There’s a quote mismatch here: you should not end the quote after
“forwarded”... but there should be a paragraph break after “forwarded.”, which
makes the quoting awkward.  I suggest handling the quote differently and
eliminating the need for awkward cross-paragraph quotation.  So it would look
like this:

NEW
   "Multiprotocol Label Switching (MPLS) Architecture" [RFC3031]
   says that with MPLS, 'packets are "labeled" before they are
   forwarded.'  It goes on to say, “At subsequent hops, there is no
   further analysis of the packet's network layer header.  Rather, the
   label is used as an index into a table which specifies the next hop,
   and a new label".
END

— Section 2.3 —

   This specification uses the following terms:

I would say it “defines” these terms, no?

   6LoWPAN endpoints:  The nodes in charge of generating or expanding a
      6LoWPAN header from/to a full IPv6 packet.  The 6LoWPAN endpoints
      are the points where fragmentation and reassembly take place.

I gather that the usual case is that the 6LoWPAN endpoints are the first and
last nodes in an unbroken string of 6LoWPAN nodes, yes?  If that’s correct, I
think it would add to easy understanding if you said that.  (And if it’s not
correct, we might want to figure out why I got that impression.)

— Section 4 —

   4. Limits of Per-Hop Fragmentation and Reassembly

   There are at least 2 limits to doing per-hop fragmentation and
   reassembly.  See [ARTICLE] for detailed simulation results on both
   limits.

Should this be “limitations”, rather than “limits”?  It seems so.  Also
throughout Section 6.

— Section 5 —

   error and refrain from creating a state or attempting to forward.

Make it “refrains”.

— Section 6 —
(Change “limits” to “limitations” throughout the section.)
Doesn’t this section need LWIG-VRB to be a normative reference?

      because the IP header is required to route the
      fragment and is only present in the first fragment.

This sounds as if the IP header has to do some routing.  If you say “is
required in order to route...”, that ambiguity goes away.

— Section 7 —

      along a path, but each node suffers a lesser hit. this is because

Capitalize “This”.

      An implementation MUST protect itself to
      keep the number of VRBs within capacity, and that old VRBs are

You need another word before “that”: maybe “ensure”?

      This sounds
      difficult and mostly useless in a 6LoWPAN network since the
      fragmentation is not end-to-end.

“Sounds”?  “Is”, I should think; no?

— Section 9 —

   Also many thanks to Georgies Papadopoulos

I believe it’s “Georgios”.

   and Francesca Palombini For their constructive
   reviews through the IESG process.

Lower-case “for”.  And did Sarah, Joerg, and Francesca really review this
through the IESG process, when the IESG process is just now starting?

---

From: Barry Leiba <[email-masked]>
Date: Thu, 5 Mar 2020 12:28:36 -0500

Hi, Pascal,

> It seems that this is the review you made on version 10. I scanned and could not make a difference.

It took me a while to figure out what you were questioning, and now I
understand: you wondered why I reposted the same comments for the -12
version as I had for the -10 version.  Sorry for the confusion, but
that was just an artifact of your posting quick updates (which I do
NOT consider a problem; I'd rather see updates posted!).  The only
purpose for updating my comments, which then got attached to version
-12, was to add the comments at the bottom from Murray.  I did not
actually change any of my own comments there, and, yes, I know you did
address them (thanks!).

Again, sorry for the confusion.  All is good.

Barry

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Thu, 5 Mar 2020 17:34:42 +0000

Then we're cool, since Murray's comment collided with one from Ben that I addressed in -13.

Many thanks to you and Murray!

Pascal

> -----Original Message-----
> Sent: jeudi 5 mars 2020 18:29
> To: Pascal Thubert (pthubert) <[email-masked]>
> Cc: The IESG <[email-masked]>; [email-masked];
> Carles Gomez <[email-masked]>; [email-masked]; [email-masked]
> Subject: Re: Barry Leiba's No Objection on draft-ietf-6lo-minimal-fragment-
> 12: (with COMMENT)
> 
> Hi, Pascal,
> 
> version as I had for the -10 version.  Sorry for the confusion, but that was just
> an artifact of your posting quick updates (which I do NOT consider a
> problem; I'd rather see updates posted!).  The only purpose for updating my
> comments, which then got attached to version -12, was to add the
> comments at the bottom from Murray.  I did not actually change any of my
> own comments there, and, yes, I know you did address them (thanks!).
>